### Function

# Fwupd build_history_report_json

since: 1.0.4

#### Declaration [src]

    gchar*
    fwupd_build_history_report_json (
      GPtrArray* devices,
      GError** error
    )

#### Description [src]

Builds a JSON report for the list of devices. No filtering is done on the `devices` array, and it is expected that the caller will filter to something sane, e.g. `FWUPD_DEVICE_FLAG_REPORTED` at the bare minimum.

Available since: 1.0.4

#### Parameters

`devices`

  Type: An array of `None`

  Devices.

  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gchar*`

A string, or `NULL` if the ID is not present.

The caller of the function takes ownership of the data, and is responsible for freeing it.
The value is a NUL terminated UTF-8 string.